/********************************************
  数字I/O口实例程序
  按键在2号引脚
  按键按下时，13号引脚的LED点亮，同时通过串口发送合计的按键次数，当松开按键时，LED熄灭
  
  created 2011
  checked 2012 5
  by Nille 
  Email：chenille@126.com
 
  This example code is in the public domain.
*********************************************/

int keySum = 0;			//按键次数

/**********************************************
      初始化部分——setup函数
**********************************************/
void setup() 
{ 
  //设置串口波特率为9600bps
  Serial.begin(9600); 
  //设置13号引脚为输出
  pinMode(13, OUTPUT);
  //设置2号引脚为输入
  pinMode(2, INPUT);
} 

/**********************************************
      执行部分——loop函数
**********************************************/
void loop() 
{ 
  //判断按键是否按下
  if(LOW == digitalRead(2))
  {
    //延时去抖
    delay(50);
    if(LOW == digitalRead(2))
    {
      //点亮LED
      digitalWrite(13,HIGH);
      keySum++;
      //发送按键次数
      Serial.println(keySum, DEC);
      while(1)
      {
        //判断是否松开按键
        if(HIGH == digitalRead(2))
        {
          //延时去抖
          delay(50);
          if(HIGH == digitalRead(2))
          break;
        }
      }
      //熄灭LED
      digitalWrite(13,LOW);
    }
  }
}
