/********************************************
伺服电机应用实例程序
  
舵机初始位置在角度0度，高电平脉宽为1.5ms
	
计算机发送“W”，高电平脉宽增加10μs，同时回复当前高电平脉宽
达到最大角度时，舵机角度不再增加

计算机发送“S”，高电平脉宽减少10μs，同时回复当前高电平脉宽
达到最小角度时，舵机角度不再减少
	
舵机占用引脚8
  
created 2011
checked 2012 5
by Nille 
Email：chenille@126.com
 
This example code is in the public domain.
*********************************************/

uint16_t  angle=1500;		//定义初始脉宽值

/**********************************************
    初始化部分——setup函数
**********************************************/

void setup() 
{                
  //初始化串口，通信速率为9600
  Serial.begin(9600);
  //舵机占用引脚8，设为输出
  pinMode(8, OUTPUT);  
}

/**********************************************
    执行部分——loop函数
**********************************************/
void loop()
{
  //判断是否收到计算机发送的数据
  if ( Serial.available()) 
  {
    switch(Serial.read())
    {
        //收到“W”，高电平脉宽增加10μs 
	case 'W':
          angle += 10;
          if(angle >2500)
          angle =2500;// 达到最大角度时，舵机角度不再增加
          break; 
        //收到“S”，高电平脉宽减少10μs， 
        case 'S':
          angle -= 10;
          if(angle <500)
          angle =500;// 达到最小角度时，舵机角度不再减少
          break;      
        default:
          break;
    } 
    //回复当前高电平脉宽
    Serial.println(angle,DEC);
  }
 
  //输出高电平
  digitalWrite(8, HIGH); 
  //脉宽为angle
  delayMicroseconds(angle);  
  //输出低电平
  digitalWrite(8, LOW); 
  //低电平持续15ms
  delay(15); 
}
